=== debian/changelog ===
netcdf (1:4.10.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Use debrebuild instead of reprotest.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Drop obsolete Breaks/Replaces.
  * Update copyright file.
  * Refresh patches.
  * Update symbols for 4.10.0.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 26 Feb 2026 05:45:26 +0100
